/****
*
*     Note:
*
*    //@@@ style comments = new changes
*
*/

#include "website.ch"


//@@@ Statics

STATIC scQuery, soIni, scCmd



//
PROC MAIN( cCmd, cRecno )  // --> CMD line params. passed by server
LOCAL oCgi, aCmd, cQuery

SET DATE BRITISH
SET DATE FORMAT TO "dd/mm/yyyy"

IF cCmd == NIL
   cCmd := ""
ENDIF

IF "%" $ cCmd
   cCmd := DecodeURL( cCmd )
   aCmd := listAsArray( cCmd, " ")
   cCmd := aCmd[1]
   IF LEN( aCmd ) > 1
      cRecno := aCmd[2]
   ENDIF
ENDIF

scCmd := cCmd


IF "POST" $ UPPER(GETENV("REQUEST_METHOD"))
      oCgi   := oCGI():New()
      cQuery := UPPER(oCgi:query_String)          // just in case...
ELSE
      oCgi   := oCGI():New()
      cQuery := UPPER(GETENV("QUERY_STRING"))
ENDIF

scQuery := cQuery
soIni := oIni():New("website.ini")
soIni:read()
soIni:close()

//
//  simple redirection based on command line arguments.
//  Each of the following routines produces stand alone HTML/CGI output
//
//

IF "BLDPAGE" $ cCmd
    FormDemo(oCgi,cRecno)
ELSEIF "POST" $ cCmd
    PostData(oCgi,cRecno)
ELSE
    BlankPage()
ENDIF

RETURN


//
PROC FormDemo(oCgi,cRecno)
LOCAL oHtm
LOCAL oForm, oForm1,oUser, oPass, oLbx

LOCAL oText1, oText2,oText3,oText4, oTArea
LOCAL oBut1, oBut2
LOCAL oSub, oReset

DEFAULT cRecno := ""

DEFINE CGI ;
       TITLE "Guest Book" ;
       BGIMAGE (COMMON_BGIMAGE) ;
       BGCOLOR (COMMON_BGCOLOR) ;
       OF oHtm


Start Font "Courier" SIZE 2 OF oHtm

oHtm:write("<br><br>")
oHtm:write("<P ALIGN='right'>")

DEFINE FORM oForm1 NAME "Harbour Guest Book" ;
       FRAME ;
       COLOR "WHITE" ;
       CAPTION [<IMG SRC='/images/email/email1.gif' onClick='history.back()' height=40>]+htmlspace(2)+"Mail form" ;
       CAPFONTCOLOR "red" ;
       WIDTH 100 ;
       METHOD 'POST' ;
       ACTION '"/cgi-bin/guestbook1.exe?POST"' //@@@ Note .EXE name (change appropriately) !!!


//@@@  Changed DEFINE to CONTROL
//@@@  Changed field widths
//@@@  Added a <TEXTAREA>

CONTROL OF oText3 HIDDEN Name "subject" ;
       VALUE "Isso e um Teste"  ;
       IN oForm1

CONTROL OF oText1  EDIT NAME "text1" ;
       VALUE "" ;
       MAXCHARS 50 ;
       SIZE 50 ;
       CAPTION "<b>"+(htmlPadL("Name : ",20) )+"</b>" ;
       IN oForm1

LINE BREAK IN oForm1

CONTROL OF oText2 EDIT NAME "text2" ;
       VALUE "http://" ;
       MAXCHARS 80 ;
       SIZE 50 ;
       CAPTION "<b>"+(htmlPadL("Home Page : ",20) )+"</b>" ;
       IN oForm1

LINE BREAK IN oForm1

CONTROL OF oText2 EDIT NAME "text3" ;
       VALUE "" ;
       MAXCHARS 50 ;
       SIZE 50 ;
       CAPTION "<b>"+(htmlPadL("Email : ",20) )+"</b>" ;
       IN oForm1

LINE BREAK IN oForm1

CONTROL OF oTArea  TEXTAREA NAME "TArea1" ;
       COLS 60 ;
       ROWS 6 ;
       ALIGN TOP ;
       CAPTION "<b>"+(htmlPadL("Message : ",20) )+"</b>" ;
       IN oForm1

LINE BREAK IN oForm1
LINE BREAK IN oForm1
SPACE 25 IN oForm1
DEFINE SUBMIT oSub NAME "cSubmit" VALUE "    Submit    " IN oForm1


ACTIVATE oForm1
oHtm:WriteLN("Guestbook1.exe Create with "+VERSION()+" and HTMLLIB")
oForm1 := NIL

//

oHtm:write("</P>")
oHtm:cgiClose()


RETURN



//@@@
//@@@  Error message accepts a <cMessage> parameter
//@@@  Error message contains a "go back" button
//@@@

//
PROCEDURE BlankPage( oCgi, cMessage )
LOCAL oHtm

DEFINE CGI ;
       BGIMAGE (COMMON_BGIMAGE) ;
       BGCOLOR (COMMON_BGCOLOR) ;
       TITLE "ACTION Error !!!" ;
       OF oHtm

oHtm:SetTextColor("black")
Start Font "VERDANA" SIZE 3 OF oHtm
oHtm:Setcenter( .T. )

oHtm:WriteLN("<br>")
oHtm:WriteLN("<b><u>ERROR !!!</u></b>")
oHtm:WriteLN("<br>")

if cMessage != NIL
   oHtm:WriteLN( cMessage )
else
   oHtm:WriteLN("Please specify an appropriate action...")
endif


oHtm:WriteLN("<br><br><center>")
oHtm:WriteLN("<form>")
oHtm:WriteLN("<input type=button value='  Go Back  ' "+;
                    "onClick='history.back();return true;'>")
oHtm:WriteLN("</form>")
oHtm:WriteLN("<br><br></center>")


oHtm:cgiClose()

RETURN



//@@@  includes some eMail validation check
//@@@  Saves messages to guestbk.txt (HTML formatted)
//@@@  Presents the user with his message and all previous messages
//@@@  underneath

//
Procedure PostData(oCgi,cRecno)
LOCAL lOk := .F.
LOCAL ohtm


lOk = ( AT( "@", oCgi:text3 ) > 0 .AND. ;
        AT( ".", oCgi:text3 ) > 0 )

IF !lOk
   blankPage( oCgi, "Please fill in your <u><b>email address</b></u> !!!" )
   return
endif


DEFINE CGI ;
       TITLE "Guest Book" ;
       BGIMAGE (COMMON_BGIMAGE) ;
       BGCOLOR (COMMON_BGCOLOR) ;
       OF oHtm


Start Font "VERDANA" SIZE 4 OF oHtm

oHtm:writeLN("<center><u><b>Thank you</u></b></center><br>" )

Start Font "Courier New, Courier, Verdana" SIZE 2 OF oHtm

oHtm:write("<b><u>You Wrote:</b></u><br><br>")

oHtm:writeln( "<b>"+htmlPadr("Name"     ,10)+": </b>" + oCgi:text1 )
oHtm:writeln( "<b>"+htmlPadr("HomePage" ,10)+": </b>" + oCgi:text2 )
oHtm:writeln( "<b>"+htmlPadr("EMail"    ,10)+": </b>" + oCgi:text3 )
oHtm:writeln( "<b>"+htmlPadr("Message"  ,10)+": </b><br>" + decodeURL( oCgi:TArea1 ) )


// --> remove previous messages from here

oHtm:write("<br><b><u>Others Wrote:</u></b><br><UL>")
memowrit( "guestbk.txt", ;
           "<LI>"+;
           "<b>"+htmlPadr("Name"     ,10)+": </b>" + oCgi:text1+"<br>"+CRLF()+;
           "<b>"+htmlPadr("HomePage" ,10)+": </b>" + oCgi:text2+"<br>"+CRLF()+;
           "<b>"+htmlPadr("EMail"    ,10)+": </b>" + oCgi:text3+"<br>"+CRLF()+;
           "<b>"+htmlPadr("Date"     ,10)+": </b>" + DTOC(DATE())+"<br>"+CRLF()+;
           "<b>"+htmlPadr("Message"  ,10)+": </b><br>" + decodeURL( oCgi:TArea1 )+"<br><hr><br>"+CRLF()+;
           MEMOREAD( "guestbk.txt" ) )

oHtm:writeLN( "<br>"+MEMOREAD("guestbk.txt" ) )
oHtm:writeLN( "</UL>")

// --> remove previous messages up to here

ohtm:CgiClose()

RETURN



/****
*
*     DecodeURL()
*
*     Decodes a URL encoded string. Also handles international charsets.
*
*     NOTE: altered %0D%0A for HTML output...
*
*/

FUNCTION DecodeURL(cString)
LOCAL i
LOCAL aGreek := GREEK_CGI

   DO WHILE "%26" $ cString
      cString := STUFF(cString, AT("%26", cString), 3, "&")
   ENDDO

   DO WHILE "%2B" $ cString
      cString := STUFF(cString, AT("%2B", cString), 3, "+")
   ENDDO

   DO WHILE "%20" $ cString
      cString := STUFF(cString, AT("%20", cString), 3, " ")
   ENDDO

   DO WHILE "%27" $ cString
      cString := STUFF(cString, AT("%27", cString), 3, "'")
   ENDDO

   DO WHILE "+" $ cString
      cString := STUFF(cString, AT("+", cString), 1, " ")
   ENDDO

   DO WHILE "%2C" $ cString
      cString := STUFF(cString, AT("%2C", cString), 3, ",")
   ENDDO

   DO WHILE "%21" $ cString
      cString := STUFF(cString, AT("%21", cString), 3, "!")
   ENDDO

   DO WHILE "%7E" $ cString
      cString := STUFF(cString, AT("%7E", cString), 3, "~")
   ENDDO

   DO WHILE "%23" $ cString
      cString := STUFF(cString, AT("%23", cString), 3, "#")
   ENDDO

   DO WHILE "%24" $ cString
      cString := STUFF(cString, AT("%24", cString), 3, "!")
   ENDDO

   DO WHILE "%25" $ cString
      cString := STUFF(cString, AT("%25", cString), 3, "%")
   ENDDO

   DO WHILE "%5E" $ cString
      cString := STUFF(cString, AT("%5E", cString), 3, "^")
   ENDDO

   DO WHILE "%28" $ cString
      cString := STUFF(cString, AT("%28", cString), 3, "(")
   ENDDO

   DO WHILE "%29" $ cString
      cString := STUFF(cString, AT("%29", cString), 3, ")")
   ENDDO

   DO WHILE "%60" $ cString
      cString := STUFF(cString, AT("%60", cString), 3, "`")
   ENDDO

   DO WHILE "%2F" $ cString
      cString := STUFF(cString, AT("%2F", cString), 3, "/")
   ENDDO

   DO WHILE "%3A" $ cString
      cString := STUFF(cString, AT("%3A", cString), 3, ":")
   ENDDO

   DO WHILE "%3B" $ cString
      cString := STUFF(cString, AT("%3B", cString), 3, ";")
   ENDDO

   DO WHILE "%3C" $ cString
      cString := STUFF(cString, AT("%3C", cString), 3, "<")
   ENDDO

   DO WHILE "%3E" $ cString
      cString := STUFF(cString, AT("%3E", cString), 3, ">")
   ENDDO

   DO WHILE "%3F" $ cString
      cString := STUFF(cString, AT("%3F", cString), 3, "?")
   ENDDO

   DO WHILE "%22" $ cString
      cString := STUFF(cString, AT("%22", cString), 3, '"')
   ENDDO

   DO WHILE "%5C" $ cString
      cString := STUFF(cString, AT("%5C", cString), 3, "\")
   ENDDO

   DO WHILE "%5B" $ cString
      cString := STUFF(cString, AT("%5B", cString), 3, "[")
   ENDDO

   DO WHILE "%5D" $ cString
      cString := STUFF(cString, AT("%5D", cString), 3, "]")
   ENDDO

   DO WHILE "%7B" $ cString
      cString := STUFF(cString, AT("%7B", cString), 3, "{")
   ENDDO

   DO WHILE "%7D" $ cString
      cString := STUFF(cString, AT("%7D", cString), 3, "}")
   ENDDO

   DO WHILE "%0D%0A" $ cString
      cString := STUFF(cString, AT("%0D%0A", cString), 3, "<br>")
   ENDDO

   DO WHILE "%0A" $ cString
      cString := STUFF(cString, AT("%0A", cString), 3, "")
   ENDDO

   FOR i=1 TO LEN( aGreek )
       DO WHILE aGreek[i,2] $ cString
          cString := STUFF(cString, AT( aGreek[i,2], cString), 3, aGreek[i,1] )
       ENDDO
   NEXT


RETURN cString


/*******/

